
set echo on
set serverout on
--
-- New in 10g - collection equality comparison...
--
DECLARE

   nt0 varchar2_ntt := varchar2_ntt('A','B','C');
   nt1 varchar2_ntt := varchar2_ntt('C','D','E');
   nt2 varchar2_ntt := varchar2_ntt('C','D','E');

   PROCEDURE compare (
             test_in IN VARCHAR2,
             ntl_in  IN varchar2_ntt,
             ntr_in  IN varchar2_ntt
             ) IS
   BEGIN
      DBMS_OUTPUT.PUT(RPAD('['||test_in||']',30) || '=> ');
      IF ntl_in = ntr_in THEN
         DBMS_OUTPUT.PUT_LINE( 'EQUAL' );
      ELSE
         DBMS_OUTPUT.PUT_LINE( 'NOT EQUAL' );
      END IF;
   END compare;     

BEGIN

   /* Compare populated collections... */
   compare( '1: nt0->nt1, populated', nt0, nt1 );
   compare( '2: nt1->nt2, populated', nt1, nt2 );

   /* Compare collections after deletion... */
   nt0.DELETE;
   nt1.DELETE;
   compare( '3: nt0->nt1, deleted', nt0, nt1 );

   /* Compare newly initialised collections... */
   nt0 := varchar2_ntt();
   nt1 := varchar2_ntt();
   compare( '4: nt0->nt1, initialised', nt0, nt1 );

END; 
/
