--
-- New 10g SUBMULTISET expressions. Used to compare some elements
-- of one collection with another...
--
DECLARE

   nt1 varchar2_ntt := varchar2_ntt( 'C','D','E' );
   nt2 varchar2_ntt := varchar2_ntt( 'C','D','E','E' ); 
   nt3 varchar2_ntt := varchar2_ntt( 'A','B','C' );

   PROCEDURE test (
             test_in   IN VARCHAR2,
             result_in IN BOOLEAN
             ) IS
   BEGIN
      DBMS_OUTPUT.PUT( RPAD('[' || test_in || ']',30) || '=> ');
      DBMS_OUTPUT.PUT_LINE(CASE
                              WHEN result_in 
                              THEN 'TRUE' 
                              ELSE 'FALSE'
                           END);
   END test;

BEGIN

   /* SUBMULTISET tests... */
   test( 'nt1 SUBMULTISET OF nt2', nt1 SUBMULTISET OF nt2 );
   test( 'nt2 SUBMULTISET OF nt3', nt2 SUBMULTISET OF nt3 );
   test( 'nt2 NOT SUBMULTISET OF nt3', nt2 NOT SUBMULTISET OF nt3 );

   /* MEMBER OF tests... */
   test( 'D MEMBER OF nt1', 'D' MEMBER OF nt1 );
   test( 'F MEMBER OF nt3', 'F' MEMBER OF nt3 );

END;
/
