
DROP TYPE complex_ntt;
DROP TYPE complex_ot;

set echo on

CREATE TYPE complex_ot AS OBJECT
( attr_one   VARCHAR2(10)
, attr_two   VARCHAR2(10)
, attr_three NUMBER(3)
, MAP MEMBER FUNCTION sort_key RETURN VARCHAR2 );
/

CREATE TYPE BODY complex_ot AS
   MAP MEMBER FUNCTION sort_key RETURN VARCHAR2 IS
   BEGIN
      RETURN LPAD(attr_one,10) ||
             LPAD(attr_two,10) ||
             TO_CHAR(attr_three,'fm000');
   END;
END;
/


CREATE TYPE complex_ntt AS TABLE OF complex_ot;
/

DECLARE
   nt complex_ntt := complex_ntt(complex_ot('data', 'more data', 1),
                                 complex_ot('data', 'some data', 2),
                                 complex_ot('data', 'dupe data', 3),
                                 complex_ot('data', 'dupe data', 3));
BEGIN
   DBMS_OUTPUT.PUT_LINE( 'Complex collection has ' ||
                         TO_CHAR(CARDINALITY(SET(nt))) ||
                         ' distinct elements.' );
END;
/
