
--
-- EMPTY tests...
--
DECLARE

   nt_null        varchar2_ntt;
   nt_initialised varchar2_ntt := varchar2_ntt();
   nt_populated   varchar2_ntt := varchar2_ntt('A','B','C');

   PROCEDURE test (
             test_in   IN VARCHAR2,
             result_in IN BOOLEAN
             ) IS
   BEGIN
      DBMS_OUTPUT.PUT( RPAD('[' || test_in || ']',40) || '=> ');
      DBMS_OUTPUT.PUT_LINE(CASE
                              WHEN result_in 
                              THEN 'TRUE' 
                              ELSE 'FALSE'
                           END);
   END test;

BEGIN

   /* First test the NULL collection... */
   test( 'nt_null IS EMPTY', nt_null IS EMPTY );
   test( 'nt_null IS NOT EMPTY', nt_null IS NOT EMPTY );


   /* Test the valid collections... */
   test( 'nt_initialised IS EMPTY', nt_initialised IS EMPTY );
   test( 'nt_populated IS NOT EMPTY', nt_populated IS NOT EMPTY );

   /* Delete the populated collection and repeat test for emptiness... */
   nt_populated.DELETE;
   test( 'nt_populated (deleted) IS NOT EMPTY', nt_populated IS NOT EMPTY );

END;
/
